/*
 */
package net.gorry.android.input.nicownng;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.webkit.WebView;
import android.widget.Toast;
public class NicoWnnGMain extends Activity {
	@Override public void onCreate(final Bundle saveInstanceState) {
		super.onCreate(saveInstanceState);
		final WebView webView = new WebView(this);
		webView.getSettings().setJavaScriptEnabled(true);
		final Js2Java js2Java = new Js2Java(this);
		webView.addJavascriptInterface(js2Java, "android");
		webView.loadUrl("file:///android_asset/openwnn_main.html");
		setContentView(webView);
	}

	public class Js2Java {
		private final Context me;

		public Js2Java(final Context context) {
			me = context;
		}

		public void callback(final String msg) {
			if (msg.equalsIgnoreCase("languageSetting")) {
				final Intent intent = new Intent(Intent.ACTION_MAIN);
				intent.setClassName("com.android.settings", "com.android.settings.LanguageSettings");
				me.startActivity(intent);
				return;
			}
			if (msg.equalsIgnoreCase("config")) {
				final Intent intent = new Intent(
						me, NicoWnnGControlPanelJAJP.class
				);
				intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
				me.startActivity(intent);
				return;
			}
			if (msg.substring(0, 5).equalsIgnoreCase("easy_")) {
				final int mode = Integer.parseInt(msg.substring(5, 6));
				final int size = Integer.parseInt(msg.substring(7, 8));
				int different_pl = -1;
				int p_nicoflick_mode = -1;
				String p_input_mode = null;
				int p_change_kana_12key = -1;
				int p_change_alphanum_12key = -1;
				int p_size = -1;
				final String l_input_mode = null;
				int l_change_kana_12key = -1;
				int l_change_alphanum_12key = -1;
				int l_size = -1;
				switch (mode) {
					case 1:
						different_pl = 1;
						p_input_mode = NicoWnnG.INPUTMODE_NORMAL;
						p_change_kana_12key = 1;
						p_change_alphanum_12key = 1;
						p_size = size;
						p_nicoflick_mode = 0;
						l_change_kana_12key = 0;
						l_change_alphanum_12key = 0;
						l_size = size;
						break;

					case 2:
						different_pl = 1;
						p_input_mode = NicoWnnG.INPUTMODE_NORMAL;
						p_change_kana_12key = 1;
						p_change_alphanum_12key = 1;
						p_size = size;
						p_nicoflick_mode = 1;
						l_change_kana_12key = 0;
						l_change_alphanum_12key = 0;
						l_size = size;
						break;

					case 3:
						different_pl = 1;
						p_input_mode = NicoWnnG.INPUTMODE_2TOUCH;
						p_change_kana_12key = 1;
						p_change_alphanum_12key = 1;
						p_size = size;
						p_nicoflick_mode = 0;
						l_change_kana_12key = 0;
						l_change_alphanum_12key = 0;
						l_size = size;
						break;

					case 4:
						different_pl = 1;
						p_change_kana_12key = 0;
						p_change_alphanum_12key = 0;
						p_size = size;
						l_change_kana_12key = 0;
						l_change_alphanum_12key = 0;
						l_size = size;
						break;

				}

				final SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(me);
				final SharedPreferences.Editor editor = pref.edit();
				if (different_pl >= 0) {
					editor.putBoolean("different_pl", (different_pl > 0) );
				}
				if (p_nicoflick_mode >= 0) {
					editor.putString("nicoflick_mode"+"_portrait", String.valueOf(p_nicoflick_mode));
				}
				if (p_input_mode != null) {
					editor.putString("input_mode"+"_portrait", p_input_mode);
				}
				if (p_change_kana_12key >= 0) {
					editor.putBoolean("change_kana_12key"+"_portrait", (p_change_kana_12key > 0) );
				}
				if (p_change_alphanum_12key >= 0) {
					editor.putBoolean("change_alphanum_12key"+"_portrait", (p_change_alphanum_12key > 0) );
				}
				if (p_size >= 1) {
					editor.putString("mainview_height_mode2"+"_portrait", String.valueOf(p_size-1));
				}
				if (l_input_mode != null) {
					editor.putString("input_mode"+"_landscape", l_input_mode);
				}
				if (l_change_kana_12key >= 0) {
					editor.putBoolean("change_kana_12key"+"_landscape", (l_change_kana_12key > 0) );
				}
				if (l_change_alphanum_12key >= 0) {
					editor.putBoolean("change_alphanum_12key"+"_landscape", (l_change_alphanum_12key > 0) );
				}
				if (l_size >= 1) {
					editor.putString("mainview_height_mode2"+"_landscape", String.valueOf(l_size-1));
				}
				editor.commit();
				Toast.makeText(
						getApplicationContext(),
						R.string.js2java_accepted_easy,
						Toast.LENGTH_LONG
				).show();
				return;
			}
		}
	}
}